extern long int my_rand();

template <class T>
class array {
public:
  int push(T item);

private:
  T *data;
  int used;
  int size;
};

template <class T>
int array<T>::push(T item)
{
  if (used == size) {
    size *= 2;
    T *temp = data;
    data = new T[size];
    for (int i = 0; i < used; i++)
      data[i] = temp[i];
    delete [] temp;
  }
  data[used++] = item;
  return 1;
}

class sample
{
public:
  void test();

protected:
  int n;
  double delta;
  array<double> data;
};


void sample::test()
{
  for (int i = 0; i < n; i++)
    if (!data.push((double)i + my_rand() * 0.0003))
      return;
}
